
'=======================================================
'                                                      '
'            -------------------------                 '
'            MouseOverControlsTest.inc                 '
'            -------------------------                 '
'                                                      '
' This include code will let you know when the mouse   ' 
' position is over a control that you specify.         '
'                                                      '
'                  By Andy1966.                        '
'                                                      '
'=======================================================


'===========================================================
' To begin, we need this function for the mouse coordinates.
'===========================================================

$ifndef __windowssdk_inc__
    declare "user32",GetCursorPos(pPoint:POINTAPI),INT
$endif

'============================================
' Define the X & Y coordinates for the mouse.
'============================================

Type CPos
     Def XpositionOfMouse:int
     Def YpositionOfMouse:int
Endtype

Def pt:Cpos

'============================================================
' Somewhere to store the control & window coordinates, sizes,
' and can store up to 1,000 controls & 1,000 windows.
'============================================================

'Used for storing the control's deatils.
type OverC
	  int ControlDown
	  int ControlAcross
	  int ControlWidth
	  int ControlHeight
	  int ControlNumber
	  int ControlOverNumber
     UINT ControlsWindow
     string ControlsWindowName
endtype

DEF Ctrl as POINTER
    Ctrl = NEW(OverC,1)
SETTYPE Ctrl, OverC

'Used for copying the control's deatils.
type OverCC
	  int ControlDownC
	  int ControlAcrossC
	  int ControlWidthC
	  int ControlHeightC
	  int ControlNumberC
	  int ControlOverNumberC
     UINT ControlsWindowC
     string ControlsWindowNameC
endtype

DEF CtrlC as POINTER
    CtrlC = NEW(OverCC,1)
SETTYPE CtrlC, OverCC

'Used for storing the window's details.
type OverW
     int WindowDown
     int WindowAcross
     int WindowWidth
     int WindowHeight
     int WindowOverNumber
     int WindowControlsStartAt
     int WindowControlsEndAt
     Uint WindowPointer
     string WindowDesc
endtype

DEF WinCtrl as POINTER
WinCtrl = NEW(OverW,1)
SETTYPE WinCtrl, OverW

'Used for copying the window's details.
type OverWC
     int WindowDownC
     int WindowAcrossC
     int WindowWidthC
     int WindowHeightC
     int WindowOverNumberC
     int WindowControlsStartAtC
     int WindowControlsEndAtC
     Uint WindowPointerC
     string WindowDescC
endtype

DEF WinCtrlC as POINTER
WinCtrlC = NEW(OverWC,1)
SETTYPE WinCtrlC, OverWC

'==================================
' Some variables and counters used.
'==================================

int ControlXpos        = 0
int ControlYpos        = 0
int WindowXpos         = 0
int WindowYpos         = 0
int ControlUpdated     = 0
INT WindowUpdated      = 0
int MouseIsOver        = 0
int NoLongerOver       = 0
int MouseIsOverControl = 0
int MouseIsOverWindow  = 0
int MouseOverCounter1  = 0		
int MouseOverCounter2  = 0
int MouseOverCounter3  = 0
int MouseOverCounter4  = 0
int MouseOverCounter5  = 0
int CurrentWindow      = 0
int CopyPointerNo      = 0
int ControlIndex       = -1
int WindowIndex        = -1
int OldWindowAcross,OldWindowDown,OldWindowWidth,OldWindowHeight,WindowMovedCheck
string LastWindow      = ""

'==========================================================================================
' Store the control co-ordinates, but first check to see if the control for that window has
' already been stored - if so update the handle of the window for that control, otherwise
' it has not been stored before - so store it.
'==========================================================================================

sub MouseOverControl(window MyWin,int MyControl,string MyWinDesc)

'================================================================================
' If control details have already been stored - update the window handle details.
'
' Closing a window and then re-opening it again causes that window to change It's
' handle details, so always update each control with the current window handle.
'================================================================================

ControlUpdated = 0

if ControlIndex >= 0
    For MouseOverCounter1 = 0 to ControlIndex
       if #Ctrl[MouseOverCounter1].ControlNumber = MyControl and #Ctrl[MouseOverCounter1].ControlsWindowName = ltrim$(MyWinDesc)
          #Ctrl[MouseOverCounter1].ControlsWindow= MyWin.hwnd
          ControlUpdated = 1
          breakfor
       endif
   next MouseOverCounter1
endif

'===============================================================
' Control details have not yet been stored - so store them here.
'===============================================================

if ControlUpdated = 0

   CopyControlsDetails()

   ControlIndex += 1
	GetSize MyWin,#Ctrl[ControlIndex].ControlAcross,#Ctrl[ControlIndex].ControlDown,#Ctrl[ControlIndex].ControlWidth,#Ctrl[ControlIndex].ControlHeight,MyControl

	WindowForMouse(MyWin,MyWinDesc)

	#Ctrl[ControlIndex].ControlNumber      = MyControl
	#Ctrl[ControlIndex].ControlsWindow     = MyWin.hwnd
	#Ctrl[ControlIndex].ControlsWindowName = ltrim$(MyWinDesc)
	#Ctrl[ControlIndex].ControlOverNumber  = 0

	if LastWindow <> #WinCtrl[WindowIndex].WindowDesc
		LastWindow =  #WinCtrl[WindowIndex].WindowDesc
		#WinCtrl[WindowIndex].WindowControlsStartAt = ControlIndex 
	endif

	#WinCtrl[WindowIndex].WindowControlsEndAt = ControlIndex

endif

return 0
endsub

'=============================================================================================================
' Here we check to see if the mouse is over a control. Returns 0 - Not over, 1 - Moved over, 2 - Remains over. 
'=============================================================================================================

sub MouseOver(window ControlsWindowIn,INT ButtonIndex,string ControlsWindowDesc),int

    MouseIsOverControl = 0

    GetCursorPos(pt)
    ControlXpos = pt.XpositionOfMouse
    ControlYpos = pt.YpositionOfMouse

     for MouseOverCounter1 = #WinCtrl[CurrentWindow].WindowControlsStartAt to #WinCtrl[CurrentWindow].WindowControlsEndAt
         if #Ctrl[MouseOverCounter1].ControlNumber = ButtonIndex and #Ctrl[MouseOverCounter1].ControlsWindow = ControlsWindowIn
            if ControlXpos >= #Ctrl[MouseOverCounter1].ControlAcross and ControlXpos <= #Ctrl[MouseOverCounter1].ControlAcross + #Ctrl[MouseOverCounter1].ControlWidth and ControlYpos >= #Ctrl[MouseOverCounter1].ControlDown and ControlYpos <= #Ctrl[MouseOverCounter1].ControlDown + #Ctrl[MouseOverCounter1].ControlHeight 
               if #Ctrl[MouseOverCounter1].ControlOverNumber = 0
                  MouseIsOverControl = 1
                  #Ctrl[MouseOverCounter1].ControlOverNumber = 1 
               else
                  MouseIsOverControl = 2
               endif
             else
                MouseIsOverControl = 0
             endif
             breakfor
         endif
     next MouseOverCounter1

return MouseIsOverControl
endsub

'=========================================================================================================================================
' Here we check to see if the mouse was over a control, and has now moved away. Returns 0 - Mouse is still over, 1 - Mouse has moved away.  
'=========================================================================================================================================

sub MouseMovedOff(window ControlsWindowIn,INT MovedOff,string MovedOffDesc),int

    NoLongerOver = 0

    for MouseOverCounter2 = #WinCtrl[CurrentWindow].WindowControlsStartAt to #WinCtrl[CurrentWindow].WindowControlsEndAt
        if #Ctrl[MouseOverCounter2].ControlNumber = MovedOff and #Ctrl[MouseOverCounter2].ControlsWindow = ControlsWindowIn
           if #Ctrl[MouseOverCounter2].ControlOverNumber = 1 and MouseIsOverControl <> 2
              #Ctrl[MouseOverCounter2].ControlOverNumber = 0
              NoLongerOver = 1 
           endif
           breakfor
        endif
    next MouseOverCounter2

return NoLongerOver
endsub

'=======================================================================
' Store the window coordinates, but first check to see if the window has
' already been stored - if so update the handle of the window, otherwise
' it has not been stored before - so store it.
'=======================================================================

sub WindowForMouse(window MyWin,string MyWinDesc)

'================================================================================
' If window details have already been stored - update the window handle details.
'
' Closing a window and then re-opening it again causes that window to change it's
' handle details, so always update each control with the current window handle.
'================================================================================

WindowUpdated = 0

if WindowIndex >= 0
   for MouseOverCounter3 = 0 to WindowIndex
       if #WinCtrl[MouseOverCounter3].WindowDesc    = ltrim$(MyWinDesc)
          #WinCtrl[MouseOverCounter3].WindowPointer = MyWin.hwnd
          WindowUpdated = 1
          breakfor
       endif
   next MouseOverCounter3
endif

'==============================================================
' Window details have not yet been stored - so store them here.
'==============================================================

if WindowUpdated = 0

   CopyWindowsDetails()

   WindowIndex += 1
	GetSize MyWin,#WinCtrl[WindowIndex].WindowAcross,#WinCtrl[WindowIndex].WindowDown,#WinCtrl[WindowIndex].WindowWidth,#WinCtrl[WindowIndex].WindowHeight
	#WinCtrl[WindowIndex].WindowPointer    = MyWin.hwnd
	#WinCtrl[WindowIndex].WindowDesc       = ltrim$(MyWinDesc)
	#WinCtrl[WindowIndex].WindowOverNumber = 0

endif

GetSize MyWin,OldWindowAcross,OldWindowDown,OldWindowWidth,OldWindowHeight

return 0
endsub

'=====================================================================================================
' Here we check to see if the mouse is over the window - Returns 0 - Not over window, 1 - Over window. 
'=====================================================================================================

sub TrackWindow(window WindowIn,string WindowInDesc),int

	 GetCursorPos(pt)
	 WindowXpos = pt.XpositionOfMouse
	 WindowYpos = pt.YpositionOfMouse

	 for MouseOverCounter4 = 0 to WindowIndex
	 	  if #WinCtrl[MouseOverCounter4].WindowDesc = ltrim$(WindowInDesc)

		    '===========================================
			 ' CurrentWindow is the window being tracked.
			 '===========================================

          CurrentWindow = MouseOverCounter4

		    '=========================================
			 ' Update the window with it's coordinates.
			 '=========================================

			 GetSize WindowIn,#WinCtrl[MouseOverCounter4].WindowAcross,#WinCtrl[MouseOverCounter4].WindowDown,#WinCtrl[MouseOverCounter4].WindowWidth,#WinCtrl[MouseOverCounter4].WindowHeight

          if OldWindowAcross <> #WinCtrl[MouseOverCounter4].WindowAcross or OldWindowDown <> #WinCtrl[MouseOverCounter4].WindowDown or OldWindowWidth <> #WinCtrl[MouseOverCounter4].WindowWidth or OldWindowHeight <> #WinCtrl[MouseOverCounter4].WindowHeight
			    GetSize WindowIn,OldWindowAcross,OldWindowDown,OldWindowWidth,OldWindowHeight
             WindowMovedCheck = 1
          else
             WindowMovedCheck = 0
          endif 

			 '======================================================
			 ' Here we check to see if the mouse is over the window.
			 '======================================================

			 if WindowXpos > #WinCtrl[MouseOverCounter4].WindowAcross and WindowXpos < #WinCtrl[MouseOverCounter4].WindowAcross + #WinCtrl[MouseOverCounter4].WindowWidth and WindowYpos > #WinCtrl[MouseOverCounter4].WindowDown and WindowYpos < #WinCtrl[MouseOverCounter4].WindowDown + #WinCtrl[MouseOverCounter4].WindowHeight 
			    MouseIsOverWindow = 1
			 else
				 MouseIsOverWindow = 0
			 endif
			 breakfor
		 endif
	 next MouseOverCounter4

   '========================================================================
   ' Update all the controls of the window with their coordinates and sizes.
   '========================================================================

   For MouseOverCounter5 = #WinCtrl[CurrentWindow].WindowControlsStartAt to #WinCtrl[CurrentWindow].WindowControlsEndAt
       getsize WindowIn,#Ctrl[MouseOverCounter5].ControlAcross,#Ctrl[MouseOverCounter5].ControlDown,#Ctrl[MouseOverCounter5].ControlWidth,#Ctrl[MouseOverCounter5].ControlHeight,#Ctrl[MouseOverCounter5].ControlNumber
	next MouseOverCounter5

return MouseIsOverWindow
endsub

sub WindowMoved(),int 
return WindowMovedCheck
endsub

'=============================================================================================
' Use this to delete the pointers used for tracking controls & windows at end of your program. 
'=============================================================================================

sub StopTracking(),int
	 delete Ctrl
	 delete WinCtrl
return 0
endsub

'========================================================================================
' New window is about to be created for the first time, store all details of the previous 
' windows that have been created first. We can then add more space in the new pointer for 
' the new window.  
'========================================================================================

sub CopyWindowsDetails(),int 

		'=============================================
		' Copy the windows details to another pointer. 
		'=============================================

      WinCtrlC = NEW(OverWC,WindowIndex+1)
      SETTYPE WinCtrlC, OverWC

      for CopyPointerNo = 0 to WindowIndex
			 #WinCtrlC[CopyPointerNo].WindowAcrossC          = #WinCtrl[CopyPointerNo].WindowAcross
			 #WinCtrlC[CopyPointerNo].WindowDownC            = #WinCtrl[CopyPointerNo].WindowDown
			 #WinCtrlC[CopyPointerNo].WindowWidthC           = #WinCtrl[CopyPointerNo].WindowWidth
			 #WinCtrlC[CopyPointerNo].WindowHeightC          = #WinCtrl[CopyPointerNo].WindowHeight
			 #WinCtrlC[CopyPointerNo].WindowPointerC         = #WinCtrl[CopyPointerNo].WindowPointer 
			 #WinCtrlC[CopyPointerNo].WindowDescC            = #WinCtrl[CopyPointerNo].WindowDesc
			 #WinCtrlC[CopyPointerNo].WindowOverNumberC      = #WinCtrl[CopyPointerNo].WindowOverNumber
          #WinCtrlC[CopyPointerNo].WindowControlsStartAtC = #WinCtrl[CopyPointerNo].WindowControlsStartAt
          #WinCtrlC[CopyPointerNo].WindowControlsEndAtC   = #WinCtrl[CopyPointerNo].WindowControlsEndAt
      next CopyPointerNo

		'============================
		' Delete the windows pointer. 
		'============================

	   delete WinCtrl

		'==============================
		' Increase the windows pointer. 
		'==============================

      WinCtrl = NEW(OverW,WindowIndex+2)
      SETTYPE WinCtrl, OverW

		'======================================================
		' Copy the windows details back to the windows pointer. 
		'======================================================

      for CopyPointerNo = 0 to WindowIndex
			 #WinCtrl[CopyPointerNo].WindowAcross          = #WinCtrlC[CopyPointerNo].WindowAcrossC
			 #WinCtrl[CopyPointerNo].WindowDown            = #WinCtrlC[CopyPointerNo].WindowDownC
			 #WinCtrl[CopyPointerNo].WindowWidth           = #WinCtrlC[CopyPointerNo].WindowWidthC
			 #WinCtrl[CopyPointerNo].WindowHeight          = #WinCtrlC[CopyPointerNo].WindowHeightC
			 #WinCtrl[CopyPointerNo].WindowPointer         = #WinCtrlC[CopyPointerNo].WindowPointerC 
			 #WinCtrl[CopyPointerNo].WindowDesc            = #WinCtrlC[CopyPointerNo].WindowDescC
			 #WinCtrl[CopyPointerNo].WindowOverNumber      = #WinCtrlC[CopyPointerNo].WindowOverNumberC
          #WinCtrl[CopyPointerNo].WindowControlsStartAt = #WinCtrlC[CopyPointerNo].WindowControlsStartAtC
          #WinCtrl[CopyPointerNo].WindowControlsEndAt   = #WinCtrlC[CopyPointerNo].WindowControlsEndAtC
      next CopyPointerNo

		'=================================
		' Delete the windows copy pointer. 
		'=================================

	   delete WinCtrlC

return 0
endsub

'========================================================================================
' New control is about to be created for the first time, store all details of the previous 
' controls that have been created first. We can then add more space in the new pointer for 
' the new control.  
'========================================================================================

sub CopyControlsDetails(),int 

		'==============================================
		' Copy the controls details to another pointer. 
		'==============================================

      CtrlC = NEW(OverCC,ControlIndex+1)
      SETTYPE CtrlC, OverCC

      for CopyPointerNo = 0 to ControlIndex
			 #CtrlC[CopyPointerNo].ControlAcrossC      = #Ctrl[CopyPointerNo].ControlAcross
			 #CtrlC[CopyPointerNo].ControlDownC        = #Ctrl[CopyPointerNo].ControlDown
			 #CtrlC[CopyPointerNo].ControlWidthC       = #Ctrl[CopyPointerNo].ControlWidth
			 #CtrlC[CopyPointerNo].ControlHeightC      = #Ctrl[CopyPointerNo].ControlHeight
			 #CtrlC[CopyPointerNo].ControlNumberC      = #Ctrl[CopyPointerNo].ControlNumber  
			 #CtrlC[CopyPointerNo].ControlOverNumberC  = #Ctrl[CopyPointerNo].ControlOverNumber
			 #CtrlC[CopyPointerNo].ControlsWindowC     = #Ctrl[CopyPointerNo].ControlsWindow
          #CtrlC[CopyPointerNo].ControlsWindowNameC = #Ctrl[CopyPointerNo].ControlsWindowName
      next CopyPointerNo

		'=============================
		' Delete the controls pointer. 
		'=============================

	   delete Ctrl

		'===============================
		' Increase the controls pointer. 
		'===============================

      Ctrl = NEW(OverC,ControlIndex+2)
      SETTYPE Ctrl, OverC

		'========================================================
		' Copy the controls details back to the controls pointer. 
		'========================================================

      for CopyPointerNo = 0 to ControlIndex
			 #Ctrl[CopyPointerNo].ControlAcross      = #CtrlC[CopyPointerNo].ControlAcrossC
			 #Ctrl[CopyPointerNo].ControlDown        = #CtrlC[CopyPointerNo].ControlDownC
			 #Ctrl[CopyPointerNo].ControlWidth       = #CtrlC[CopyPointerNo].ControlWidthC
			 #Ctrl[CopyPointerNo].ControlHeight      = #CtrlC[CopyPointerNo].ControlHeightC
			 #Ctrl[CopyPointerNo].ControlNumber      = #CtrlC[CopyPointerNo].ControlNumberC  
			 #Ctrl[CopyPointerNo].ControlOverNumber  = #CtrlC[CopyPointerNo].ControlOverNumberC
			 #Ctrl[CopyPointerNo].ControlsWindow     = #CtrlC[CopyPointerNo].ControlsWindowC
          #Ctrl[CopyPointerNo].ControlsWindowName = #CtrlC[CopyPointerNo].ControlsWindowNameC
      next CopyPointerNo

		'==================================
		' Delete the controls copy pointer. 
		'==================================

	   delete CtrlC

return 0
endsub

'=============================
' End of MouseOverControls.inc
'=============================